<template>
    <div>
        <span class="name" @click="toggleSelection">~ {{ notebook? notebook.name: 'no notebook'}}</span>
        <transition name="move-up">
            <section class="selection" v-if="open">
                <div class="action">
                    <app-icon @click="toggleSelection" icon="times-circle"></app-icon>
                </div>
                <ol class="list-of-notebooks">
                    <li
                        @click="onNotebookSelection(notebook)"
                        v-for="(notebook, index) in notebooks"
                        :key="index"
                    >{{ notebook.name}}</li>
                </ol>
            </section>
        </transition>
    </div>
</template>

<style lang="css" scoped>
.move-up-enter-active,
.move-up-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.move-up-enter,
.move-up-leave-to {
    opacity: 0;
    transform: translateY(200px);
}
</style>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'
import { INotebook, INote } from '@/store/types/notebooks'
import { IRoot } from '@/store/types/root'

@Component
export default class NotebookOfNote extends Vue {
    // Props

    @Prop() notebook: INotebook | undefined
    @Prop() note: INote | undefined

    // State

    @State((state: IRoot) => {
        if (!state.Notebooks) return []
        return state.Notebooks.notebooks
    })
    notebooks: INotebook[] | undefined

    // data

    open: boolean = false

    // Methods
    toggleSelection() {
        this.open = !this.open
    }

    onNotebookSelection(notebook: INotebook) {
        const url = `/notebook/${notebook.id}/new-note`
        const url2 =
            this.note && this.note.id
                ? `/notebook/${notebook.id}/${this.note.id}`
                : ''
        if (this.$route.fullPath !== url || this.$route.fullPath !== url2) {
            this.$emit('selectedNotebook', notebook)
            this.toggleSelection()
        }
    }
}
</script>